type Brand<T> = T & {
    readonly brand: unique symbol;
};
export type CharsPtr = Brand<number>;
export type BufferPtr = Brand<number>;
export type Ptr = Brand<number>;
export type IntPtr = Brand<number>;
export type FunctionPtr = Brand<number>;
export type StringPtr = Brand<number>;
export type ErrorPtr = Brand<number>;
export type VariantPointer = Brand<number>;
export type Bool = 0 | 1;
export declare enum QspCallType {
    DEBUG = 0,
    ISPLAYINGFILE = 1,
    PLAYFILE = 2,
    CLOSEFILE = 3,
    SHOWIMAGE = 4,
    SHOWWINDOW = 5,
    SHOWMENU = 6,
    SHOWMSGSTR = 7,
    REFRESHINT = 8,
    SETTIMER = 9,
    SETINPUTSTRTEXT = 10,
    SYSTEM = 11,
    OPENGAME = 12,
    OPENGAMESTATUS = 13,
    SAVEGAMESTATUS = 14,
    SLEEP = 15,
    GETMSCOUNT = 16,
    INPUTBOX = 17,
    VERSION = 18,
    DUMMY = 19
}
export interface QspWasmModule extends EmscriptenModule {
    addFunction(fn: (...args: never) => unknown, signature: string): FunctionPtr;
    Asyncify: {
        handleSleep(cb: (wakeUp: (ret: number) => void) => void): void;
    };
    _freeString(string: CharsPtr): void;
    _freeItemsList(items: Ptr): void;
    _freeSaveBuffer(buffer: Ptr): void;
    _freeStringsBuffer(buffer: Ptr): void;
    _init(): void;
    _dispose(): void;
    _setErrorCallback(fnPtr: FunctionPtr): void;
    _getVersion(ptr: Ptr): void;
    _getMainDesc(ptr: Ptr): void;
    _isMainDescChanged(): Bool;
    _getVarsDesc(ptr: Ptr): void;
    _isVarsDescChanged(): Bool;
    _getActions(list: Ptr): Ptr;
    _selectAction(index: number): void;
    _executeSelAction(): void;
    _isActionsChanged(): Bool;
    _getObjects(list: Ptr): Ptr;
    _selectObject(index: number): void;
    _isObjectsChanged(): Bool;
    _loadGameData(data: BufferPtr, size: number, isNewGame: Bool): void;
    _restartGame(): void;
    _saveGameData(realSize: IntPtr): Ptr;
    _loadSavedGameData(data: BufferPtr, size: number): void;
    _execString(input: CharsPtr, isRefresh: Bool): void;
    _execCounter(): void;
    _execUserInput(input: CharsPtr): void;
    _execLoc(input: CharsPtr): void;
    _getLastError(ptr: ErrorPtr): void;
    _getVarSize(name: CharsPtr): number;
    _getVarValue(name: CharsPtr, result: VariantPointer): Bool;
    _getVarValueByIndex(name: CharsPtr, index: number, result: VariantPointer): Bool;
    _getVarValueByKey(name: CharsPtr, key: CharsPtr, result: VariantPointer): Bool;
    _setCallback(type: QspCallType, fnPtr: FunctionPtr): void;
    _enableDebugMode(): void;
    _getCurStateData(location: StringPtr, actIndex: Ptr, line: Ptr): void;
    _disableDebugMode(): void;
    _getLocationsList(count: Ptr): Ptr;
    _getLocationCode(name: CharsPtr, count: Ptr): Ptr;
    _getActionCode(name: CharsPtr, index: number, count: Ptr): Ptr;
    __run_checks(): void;
}
export {};
